'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _yylibUi = require('yylib-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function noop() {}

var ItemFooter = function (_React$PureComponent) {
    _inherits(ItemFooter, _React$PureComponent);

    function ItemFooter() {
        _classCallCheck(this, ItemFooter);

        return _possibleConstructorReturn(this, (ItemFooter.__proto__ || Object.getPrototypeOf(ItemFooter)).apply(this, arguments));
    }

    _createClass(ItemFooter, [{
        key: 'getClassName',
        value: function getClassName() {
            var rootPrefixCls = this.props.rootPrefixCls;

            return (0, _classnames2.default)(rootPrefixCls + '-footer');
        }
    }, {
        key: 'renderLeft',
        value: function renderLeft() {
            var _props = this.props,
                dataItem = _props.dataItem,
                itemFooterLeftLabelDataSet = _props.itemFooterLeftLabelDataSet,
                customRenderDataSet = _props.customRenderDataSet;

            var content = [];
            itemFooterLeftLabelDataSet.map(function (_ref) {
                var key = _ref.key,
                    label = _ref.label;

                if (dataItem === null || dataItem[key]) {
                    if (dataItem !== null && customRenderDataSet[key]) {
                        content.push(customRenderDataSet[key].render({ dataItem: dataItem, key: key }));
                    } else {
                        content.push(_react2.default.createElement(
                            'span',
                            { className: (0, _classnames2.default)('label-state') },
                            label
                        ));
                    }
                }
            });
            return content;
        }
    }, {
        key: 'renderRight',
        value: function renderRight() {
            var _props2 = this.props,
                dataItem = _props2.dataItem,
                itemFooterRightButtonDataSet = _props2.itemFooterRightButtonDataSet,
                onItemFooterRightButtonClick = _props2.onItemFooterRightButtonClick,
                customRenderDataSet = _props2.customRenderDataSet;

            var content = [];
            itemFooterRightButtonDataSet.map(function (_ref2) {
                var key = _ref2.key,
                    label = _ref2.label;

                if (dataItem === null || dataItem[key]) {
                    if (dataItem !== null && customRenderDataSet[key]) {
                        content.push(customRenderDataSet[key].render({ dataItem: dataItem, key: key }));
                    } else {
                        content.push(_react2.default.createElement(
                            _yylibUi.YYButton,
                            { className: (0, _classnames2.default)('button-state'),
                                onClick: onItemFooterRightButtonClick.bind(null, key, dataItem) },
                            label
                        ));
                    }
                }
            });
            return content;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                renderItemFooterLeft = _props3.renderItemFooterLeft,
                renderItemFooterRight = _props3.renderItemFooterRight,
                dataItem = _props3.dataItem;

            return _react2.default.createElement(
                'div',
                { className: this.getClassName() },
                _react2.default.createElement(
                    'div',
                    { className: this.getClassName() + '-left' },
                    renderItemFooterLeft === null ? this.renderLeft() : renderItemFooterLeft(dataItem)
                ),
                _react2.default.createElement(
                    'div',
                    { className: this.getClassName() + '-right' },
                    renderItemFooterRight === null ? this.renderRight() : renderItemFooterRight(dataItem)
                )
            );
        }
    }]);

    return ItemFooter;
}(_react2.default.PureComponent);

ItemFooter.defaultProps = {
    rootPrefixCls: 'ijz-listitem',
    dataItem: null,
    renderItemFooterLeft: null,
    renderItemFooterRight: null,
    itemFooterLeftLabelDataSet: [],
    itemFooterRightButtonDataSet: [],
    onItemFooterRightButtonClick: noop,
    customRenderDataSet: null
};
exports.default = ItemFooter;