"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var React = require('react');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass;

var ajax = require('yylib-utils/ajax');
var YYChart = require('../../yylib2/chart/YYChart');

var ChartWidget = YYClass.create({
    componentDidMount: function componentDidMount() {
        var remoteUrl = this.props.remoteUrl;

        ajax.getJSON(remoteUrl, function (result) {
            if (this.selfChart) {
                //result的格式后端要完全返回符合要求的。
                this.selfChart.refs.refChart.chart.setOption({
                    series: result
                });
            }
        });
    },
    setOption: function setOption() {
        var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        if (this.selfChart) {
            this.selfChart.refs.refChart.chart.setOption(value);
        }
    },
    render: function render() {
        var _this = this;

        var _props = this.props,
            options = _props.options,
            props = _objectWithoutProperties(_props, ['options']);

        return React.createElement(YYChart, _extends({ ref: function ref(node) {
                return _this.selfChart = node;
            }, options: options || {} }, props));
    }
});

module.exports = ChartWidget;