"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.upload = upload;
exports.uploadToFs = uploadToFs;

/**
 * 文件上传工具
 *
 * @author 张远志
 * @time 2017年4月28日14:21:58
 */
var _require = require('yylib-business/attach/attachaction'),
    uploadUrl = _require.uploadUrl;

var AuthToken = require("yylib-utils/AuthToken");

/**
 * 文件上传
 *
 * @param datas
 * @param url
 * @param callback
 */
function upload(datas, url, callback) {
    var file = document.createElement("input");
    file.setAttribute("type", "file");
    document.body.appendChild(file);
    file.onchange = doUpload;
    file.click();

    function doUpload() {
        var form = new FormData();
        form.append("file", file.files[0]);
        for (var key in datas) {
            form.append(key, datas[key]);
        }
        var xhr = new XMLHttpRequest();
        xhr.open("post", url, true);
        xhr.setRequestHeader("authority", AuthToken.getAuthenticationStr());
        xhr.setRequestHeader("icop-token", AuthToken.getToken());
        xhr.onload = uploadComplete;
        xhr.onerror = uploadFailed;
        xhr.send(form);
    }

    function uploadComplete(event) {
        document.body.removeChild(file);
        var back = event.currentTarget.response;
        callback(JSON.parse(back));
    }

    function uploadFailed() {
        document.body.removeChild(file);
    }
}

/**
 * 上传到文件服务器
 *
 * @param datas
 * @param serverUrl
 * @param callback
 */
function uploadToFs(datas, serverUrl, callback) {
    upload(datas, serverUrl + uploadUrl, callback);
}