'use strict';

/**
 * 提示文案
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Alert = _require.Alert;
//定义META


var uiMeta = {
    name: 'alert',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('type', 'info', PropTypes.oneOf(['success', 'info', 'warning', 'error']), true, '四种类型供选择：success|info|warning|error'), field('closable', false, PropTypes.bool, false, '是否显示关闭按钮'), field('closeText', null, PropTypes.node, false, '自定义关闭按钮'), field('message', null, PropTypes.node, true, '警告提示内容'), field('description', null, PropTypes.node, false, '警告提示的辅助性文字介绍'), field('onClose', null, PropTypes.func, false, '关闭时触发的回调函数'), field('showIcon', false, PropTypes.bool, false, '是否显示辅助图标')]
    //定义组件
};var YYAlert = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        return React.createElement(
            'div',
            { className: this.className() },
            React.createElement(
                Alert,
                this.props,
                this.props.children
            )
        );
    }
});
module.exports = YYAlert;