'use strict';

/**
 * 模态对话框-界面设计器设计弹窗的预览效果
 */
var React = require('react');
var YYClass = require('../base/YYClass');
//定义META
var meta = require('./meta');
var YYModalPreview = YYClass.create({
    uiMeta: meta,
    render: function render() {
        var _props = this.props,
            title = _props.title,
            children = _props.children,
            okText = _props.okText,
            cancelText = _props.cancelText,
            draggable = _props.draggable,
            closable = _props.closable,
            width = _props.width;

        return React.createElement(
            'div',
            { className: 'yyui-modal ant-modal-content', style: { width: width, margin: '20px auto' } },
            closable ? React.createElement(
                'button',
                { className: 'yyui-modal ant-modal-close' },
                React.createElement('span', { className: 'yyui-modal ant-modal-close-x' })
            ) : null,
            React.createElement(
                'div',
                { className: 'yyui-modal ant-modal-header', style: draggable ? { cursor: 'move' } : null },
                React.createElement(
                    'div',
                    { className: 'yyui-modal ant-modal-title' },
                    title
                )
            ),
            React.createElement(
                'div',
                { className: 'yyui-modal ant-modal-body' },
                children
            ),
            React.createElement(
                'div',
                { className: 'yyui-modal ant-modal-footer' },
                React.createElement(
                    'button',
                    { type: 'button', className: 'ant-btn ant-btn-ghost ant-btn-lg' },
                    React.createElement(
                        'span',
                        null,
                        cancelText ? cancelText : "取 消"
                    )
                ),
                React.createElement(
                    'button',
                    { type: 'button', className: 'ant-btn ant-btn-primary ant-btn-lg' },
                    React.createElement(
                        'span',
                        null,
                        okText ? okText : "确 定"
                    )
                )
            )
        );
    }
});
module.exports = YYModalPreview;