'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
** 参照按钮-点击按钮弹出参照
**/
var React = require('react');
var _ = require('lodash');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
var BaseHost = require('../../business/BaseHost');
var YYReferDialog = require('./YYReferDialog');
var YYButton = require('../button/YYButton');

var _require = require('./constants/ReferConstants'),
    GET_REFINFO_BYCODE = _require.GET_REFINFO_BYCODE;

require('./style/referbutton.less');
//定义META
var uiMeta = {
    name: 'buttonrefer',
    fields: [field('serverUrl', BaseHost, PropTypes.string, true, '参照服务的地址信息(域名和端口)'), field('apiUrl', GET_REFINFO_BYCODE, PropTypes.string, true, '获取参照注册信息的api相对地址，注意：域名和端口信息需要写在serverUrl'), field('type', '', PropTypes.oneOf(['primary', 'success', 'info', 'warning', 'error', '']), false, '设置按钮类型，可选值为 primary|success|info|warning|error 或者不设'), field('buttonText', null, PropTypes.string, false, '设置按钮的文本'), field('icon', null, PropTypes.string, false, '设置按钮的图标类型'), field('visible', true, PropTypes.bool, false, '设置按钮是否显示'), field('disabled', undefined, PropTypes.bool, false, '设置按钮是否禁用'), field('ghost', null, PropTypes.bool, false, '设置按钮为不填充形态'), field('onShow', null, PropTypes.func, false, '按钮参照被打开时的回调，如果回调返回false则终止打开参照操作')]
};
var YYReferButton = YYClass.create({
    uiMeta: uiMeta,
    getInitialState: function getInitialState() {
        return {
            showRef: false
        };
    },

    _openRef: function _openRef() {
        var onShow = this.props.onShow;
        if (onShow && typeof onShow === 'function' && onShow() === false) {
            return false;
        }
        if (this.props.refinfokey) {
            this.setState({ showRef: true });
        } else {
            console.warn("refinfokey不能为空");
        }
    },
    _closeRef: function _closeRef() {
        this.setState({ showRef: false });
        if (typeof this.props.onCancel == 'function') {
            this.props.onCancel();
        }
    },
    _okRef: function _okRef(shortValue, keyField, fullValue, selectedNode) {
        this.setState({ showRef: false });
        if (typeof this.props.onOk == 'function') {
            this.props.onOk(shortValue, keyField, fullValue, selectedNode);
        }
    },
    render: function render() {
        var _props = this.props,
            buttonText = _props.buttonText,
            style = _props.style,
            type = _props.type,
            className = _props.className,
            visible = _props.visible,
            disabled = _props.disabled,
            icon = _props.icon,
            ghost = _props.ghost,
            referProps = _objectWithoutProperties(_props, ['buttonText', 'style', 'type', 'className', 'visible', 'disabled', 'icon', 'ghost']);

        return !!visible === false ? null : React.createElement(
            'div',
            { className: this.className(), style: style },
            React.createElement(YYButton, { onClick: this._openRef, children: buttonText, type: type, visible: visible, disabled: disabled, icon: icon, ghost: ghost }),
            this.state.showRef ? React.createElement(YYReferDialog, _extends({
                show: this.state.showRef }, referProps, {
                onOk: this._okRef,
                onCancel: this._closeRef
            })) : null
        );
    }
});

module.exports = YYReferButton;